
#include "gmyth_backendinfo.h"
#include "gmyth_epg.h"

static gboolean
test_epg_connection (GMythBackendInfo *backend_info)
{
    GMythEPG *epg = gmyth_epg_new ();
    gboolean res = FALSE;

    res = gmyth_epg_connect (epg, backend_info);

    gmyth_epg_disconnect (epg);
    g_object_unref (epg);

    return res; 
}


static gboolean
test_epg_get_channels (GMythBackendInfo *backend_info)
{
    GMythEPG *epg = gmyth_epg_new ();
    GList *clist;
    gint i, length;

    if (!gmyth_epg_connect (epg, backend_info)) {
        return FALSE;
    }

    length = gmyth_epg_get_channel_list (epg, &clist);
    g_print ("==== %d channels found in the EPG ====\n", length);
    for (i=0; i<length; i++) {
        GMythChannelInfo *channel_info = (GMythChannelInfo*) g_list_nth_data (clist, i);

        gmyth_channel_info_print(channel_info);
    }

    g_list_free (clist);
    gmyth_epg_disconnect (epg);
    g_object_unref (epg);
}

int
main (int args, const char **argv)
{
    const char* uri = argv[1];

    GMythBackendInfo *backend_info;
    g_type_init ();
    //g_thread_init (NULL);

    backend_info = gmyth_backend_info_new_with_uri (argv[1]);

    test_epg_connection (backend_info);
    test_epg_get_channels (backend_info);

    return 0;
}

